$(function () {
    $('#get-stats').on('click', fetchStats);
    $('#stats')
        .on('click', '.lock', true, switchQueue)
        .on('click', '.unlock', false, switchQueue);

    fetchStats();

    function fetchStats() {
        $('#stats').empty();
        $.ajax({
            type: 'GET',
            url: '/stats',
            success: showStats,
        });
    }

    function showStats(response) {
        const consumers = response.consumers;

        $('#stats')
            .append(
                Object.entries(response.workers_config).map(
                    ([key, value]) => {
                        const consumer = consumers[key];
                        const state = (response.state['workers'] || {})[key];

                        return `
                            <div data-id="${key}" class="worker-item">
                                worker: ${key} - ${consumer.worker_state}, queue: ${value.work_queue}, active: ${consumer.active}, locked: ${state ? state.locked : false}
                                <button class="lock">Lock</button>
                                <button class="unlock">Unlock</button>
                            </div>
                        `;
                    }
                ).join('')
            )
            .append(`
                <div>
                    locked all: ${response.state.locked ? true : false}
                    <button class="lock">Lock All</button>
                    <button class="unlock">Unlock All</button>
                </div>
            `);
    }

    function switchQueue(e) {
        const queue = $(this).parents('.worker-item').data('id');
        $.ajax({
            type: 'POST',
            url: '/announce',
            data: {
                'queue-lock': e.data,
                queue,
            },
            success: fetchStats,
        });
    }
});
