<?php

namespace InSegment\WorkersFramework\Interfaces;

use InSegment\WorkersFramework\Queues\LoadMeasure;

interface WorkerListInterface
{
    /**
     * Get available workers
     * 
     * @param array|null $filter
     * @return \InSegment\WorkersFramework\Services\Worker[]
     */
    public function getWorkers(array $filter = null): array;
 
    /**
     * Get load measure instance
     * 
     * @return \InSegment\WorkersFramework\Queues\LoadMeasure
     */
    public function getLoadMeasure(): LoadMeasure;
}
